if "$EUROMOD_PATH" == "" {
	global EUROMOD_PATH = "C:/Program Files/EUROMOD/Executable"
}
qui adopath + "$EUROMOD_PATH"
capture program drop EM_StataPlugin
local wd = c(pwd)
qui cd "$EUROMOD_PATH"
program EM_StataPlugin, plugin using ("$EUROMOD_PATH/StataPlugin.plugin")
capture program drop euromod_run
program define euromod_run
	// change working directory to path for plugin for plugin to function correctly. Problem with linking of CLR library with stata plugin, because lib file needs to be in the working directory.
	qui local wd = c(pwd)
	qui cd "$EUROMOD_PATH"
	global vars_EM ""
	syntax [anything(everything)], dataset(string) [REPository(string)] * 
	if ("`repository'" != "") {
		import delimited "`repository'\\`dataset'.txt",clear
	}
    version 15.1
	syntax [if] [in], SYStem(string) DATAset(string) MODel(string) country(string) [ REPository(string)  TU_output(string) VARs_output(string) il_output(string) constants(string) PREFix(string) SETtings(string) EXTRAinfo_output(string) SUPPress_output  uselogger outputdataset(string) EXTensions(string) ADDons(string) replace euro sequentialrun PUBLICcomponentsonly]
	
//DO NOT touch name of varlist_input_EM, plugin is hardcoded on the name #####
	if ("`euro'" == "euro") {
	    local settings = "`settings''FORCE_OUTPUT_EURO': 'yes',"
	}
	if ("`sequentialrun'" == "sequentialrun") {
	    local settings = "`settings''FORCE_SEQUENTIAL_RUN':'yes',"
	}
	if ("`publiccomponentsonly'" == "publiccomponentsonly") {
	    local settings = "`settings''IGNORE_PRIVATE':'yes',"
	}
	if ("`uselogger'" != "uselogger"  ) {
		local disableLogger "disableLogger"
	}
	qui ds, has(type numeric)
	local numeric_list = "`r(varlist)'"
	qui ds, has(char inputvar)
	local previous_input = "`r(varlist)'"
	
	qui ds, not(char simulated) 
	local not_simulated_list = "`r(varlist)'"
	local varlist_input_EM9870 = ""
	marksample touse
	foreach var in `numeric_list' {
		if  `: list var in not_simulated_list' {
			local varlist_input_EM9870 = "`varlist_input_EM9870' `var'"
			char `var'[inputvar] "yes"
		}
		else if `: list var in previous_input' {
		    
		    local varlist_input_EM9870 = "`varlist_input_EM9870' `var'"
		}	
	}
    qui plugin call EM_StataPlugin `varlist_input_EM9870' if `touse', "simulate" "`system'" "`model'" "`dataset'" "`repository'" "`outputdataset'" "`country'" "`vars_output'" "`il_output'" "`extrainfo_output'" "`suppress_output'" "`constants'" "`settings'" "`disableLogger'" "`extensions'" "`addons'" "`replace'"
	if (_rc != 0) {
		noi di "Something went wrong with the EM_stataPlugin. Please check the parameters that you passed to the model."
		qui cd "`wd'"
		error 9000
		exit
	}
	capture gen __simulated__ = 0
	replace __simulated__ = `touse'
	if "$vars_EM" == "" {
		qui cd "`wd'"
		exit
	}
	if ($EM_n_outputs == 1) {
		qui euromod_getdata, outputdataset($EM_outputs) prefix(`prefix') `replace'
	}
	else if "`outputdataset'" != "" {
		qui euromod_getdata, outputdataset("`outputdataset'") prefix(`prefix') `replace'
	}
end